/****************Mid report - binary phase diagram****************
Programer : Eunha Kim
ID number : 20021231
Last Update : 2006.11.04
reference state : Ps fcc Phase Diagram (Eutetic, fcc, bcc, liq)
  : bf.txt, lb.txt, lf.txt
*****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <fstream.h>
#include <conio.h>

#define num 2
#define ER 0.00001

double la1, la2, lb1, lb2, fa1, fa2, fb1, fb2, ba1, ba2, bb1, bb2, te; // 

void gaussian(int n, double **matrix); // þ ҰŹ  
void inverse(int n, double **matrix); // 
void nomalize(int n, double **matrix, int row);
void jacobian(int n, double **matrix, double x1, double x2); //ں 
void zh(double *x, double *y, int n, double **z, double **ztz, double *ztd); // [Z_t][Z], [Z_t][d]  
void solve(int n, double **matrix, double *asn); //  ķ   ش
void fvar(int n, double *x, double *y, double **z, double *a, double **ztz, double *ztd, double **matrix, double *var1, double *var2); //  
void eutetic(double *asn); // eutetic point
void l_f(double *asn); // liquid - fcc 
void l_b(double *asn); // liquid - bcc 
void b_f(double *asn); // bcc - fcc 

void main(){
	double *x, *y, **z, **ztz, ztd[num], a[num], **matrix, asn[4];	
	double gps_f_b, gks_b_f;
	int i,n;
	FILE *hm, *la, *hff, *hfb, *ba, *fa;	
	gps_f_b=10000;
	gks_b_f=7500;
	hm=fopen("HM.txt","r");
	fscanf(hm,"%d",&n); // record 
		x=malloc(n*sizeof(double));		
	y=malloc(n*sizeof(double));	
	z=(double **)calloc(n,sizeof(double *));
	ztz=(double **)calloc(num,sizeof(double *));
	matrix=(double **)calloc(num,sizeof(double *));
	for(i=0;i<n;i++){
		z[i]=(double *)calloc(num,sizeof(double));		
	}
	for(i=0;i<num;i++){
		ztz[i]=(double *)calloc(2*num,sizeof(double));
		matrix[i]=(double *)calloc(num+1,sizeof(double));		
	}// ޸ Ҵ
	
	for(i=0;i<n;i++){
		fscanf(hm,"%le",&x[i]);
		x[i]=x[i];
		fscanf(hm,"%le",&y[i]);		
		y[i]=y[i]/(x[i]*(1-x[i])); //  ȭ				
	}

	fclose(hm); // mixing enthalpy  Ϸκ Է¹		

	fvar(n,x,y,z,a,ztz,ztd,matrix,&la1,&lb1);	// la1, lb1 
	
	la=fopen("la.txt","r");
	fscanf(la,"%d",&n); // record 	
	
	for(i=0;i<n;i++){
		fscanf(la,"%le",&x[i]);
		x[i]=x[i];
		fscanf(la,"%le",&y[i]);		
		y[i]=8.314*1500*log(y[i]/x[i])/pow((1-x[i]),2); //  ȭ			
	}
	fclose(la);

	fvar(n,x,y,z,a,ztz,ztd,matrix,&la2,&lb2);
	la2=(la2-la1)/1500;
	lb2=(lb2/2-lb1)/1500; // la2, lb2 

	printf("\n la1 %le, la2 %le, lb1 %le, lb2 %le",la1,la2,lb1,lb2);

	hff=fopen("hff.txt","r");
	fscanf(hff,"%d",&n);	
	for(i=0;i<n;i++){
		fscanf(hff,"%le",&x[i]);					
		fscanf(hff,"%le",&y[i]);
		y[i]=(y[i]-7500*x[i])/(x[i]*(1-x[i]));		
	}
	fclose(hff);

	fvar(n,x,y,z,a,ztz,ztd,matrix,&fa1,&fb1); // fa1, fb1 

	fa=fopen("fa.txt","r");
	fscanf(fa,"%d",&n); // record 	
	
	for(i=0;i<n;i++){
		fscanf(fa,"%le",&x[i]);		
		fscanf(fa,"%le",&y[i]);		
		y[i]=(-7500+8.314*1100*(double)log(y[i]/x[i]))/pow((1-x[i]),2); //  ȭ			
	}
	fclose(fa);

	fvar(n,x,y,z,a,ztz,ztd,matrix,&fa2,&fb2); 
	fa2=(fa2-fa1)/1100;
	fb2=(fb2/2-fb1)/1100; // fa2, fb2 

	printf("\n fa1 %le, fa2 %le, fb1 %le, fb2 %le",fa1,fa2,fb1,fb2);

	hfb=fopen("hfb.txt","r");
	fscanf(hfb,"%d",&n);	
	for(i=0;i<n;i++){
		fscanf(hfb,"%le",&x[i]);						
		fscanf(hff,"%le",&y[i]);
		y[i]=(y[i]-(double)10000*(1-x[i]))/(x[i]*(1-x[i]));		
	}
	fclose(hfb);

	fvar(n,x,y,z,a,ztz,ztd,matrix,&ba1,&bb1); // ba1, bb1 

	ba=fopen("ba.txt","r");
	fscanf(ba,"%d",&n); // record 	
	
	for(i=0;i<n;i++){
		fscanf(ba,"%le",&x[i]);		
		fscanf(ba,"%le",&y[i]);		
		y[i]=(+8.314*1100*(double)log(y[i]/(1-x[i]))-(double)10000)/pow(x[i],2); //  ȭ
		x[i]=2*x[i]-1;
	}
	fclose(ba);

	fvar(n,x,y,z,a,ztz,ztd,matrix,&ba2,&bb2);
	ba2=(ba2-ba1)/1100;
	bb2=(bb2-bb1)/1100; // ba2, bb2 

	printf("\n ba1 %le, ba2 %le, bb1 %le, bb2 %le",ba1,ba2,bb1,bb2);
	
	eutetic(asn); // eutetic  
	b_f(asn); // bcc - fcc  
	l_f(asn); // liquid - fcc  
	l_b(asn); // liquid -bcc 
	getch();
}

void zh(double *x, double *y, int n, double **z, double **ztz, double *ztd){
	int i,j,k;
	double add1, add2;
	
	for(i=0;i<n;i++){
		z[i][0]=1;
		z[i][1]=x[i];
	}

	for(i=0;i<num;i++){
		for(j=0;j<num;j++){
			add1=0;
			for(k=0;k<n;k++){				
				add1=add1+z[k][i]*z[k][j];								
			}
			ztz[i][j]=add1;			
		}
		add2=0;
		for(k=0;k<n;k++){
			add2=add2+z[k][i]*y[k];
		}
		ztd[i]=add2;	
	}
}


void gaussian(int n, double **matrix){
	int i, j, k;
	double temp;
//	nomalize(n, matrix, 0);	
	for(i=0;i<n-1;i++){	
		for(j=i+1;j<n;j++){
			temp=matrix[j][i]/matrix[i][i];
			for(k=i;k<n+1;k++){
				matrix[j][k]=matrix[j][k]-matrix[i][k]*temp;
			}
		}		
	}
}

void nomalize(int n, double **matrix, int row){
	int i, j;
	double max;
	for(i=row;i<n;i++){
		max=(double)fabs(matrix[i][0]);
		for(j=0;j<n+1;j++){
			if(max<fabs(matrix[i][j])) max=matrix[i][j];
		}
		for(j=0;j<n+1;j++){
			matrix[i][j]=matrix[i][j]/max;
		}
	}
}

void solve(int n, double **matrix, double *asn){
	int i,j;
	double sum;
	for(i=n-1;i>=0;i--){		
		sum=0;
		for(j=i+1;j<n;j++){
			sum=sum+matrix[i][j]*asn[j];			
		}
		asn[i]=(matrix[i][n]-sum)/matrix[i][i];		
	}
}

void fvar(int n, double *x, double *y, double **z, double *a, double **ztz, double *ztd, double **matrix, double *var1, double *var2){
	int i,j,k;
	double odd=1;
	for(i=0;i<num;i++){		
			matrix[i][0]=1;
			matrix[i][1]=x[i];			
			matrix[i][2]=y[i];
	}

	gaussian(num, matrix); // þ ҰŹ  ȯ
	solve(num, matrix, a); //   
	for(i=0;i<50 && odd>ER;i++){
		*var1=a[0];
		*var2=a[1]; // ó    
		zh(x,y,n,z,ztz,ztd);
		for(j=0;j<num;j++){
			for(k=0;k<num;k++){
				matrix[j][k]=ztz[j][k];
			}
			matrix[j][num]=ztd[j];
		}	
		gaussian(num, matrix); // þ ҰŹ  ȯ
		solve(num, matrix, a); //   			
		if( fabs(*var1-a[0])>fabs(*var2-a[1]) ){ odd=fabs(*var1-a[0]);}
		else{ odd=fabs(*var2-a[1]);}	
	}
}

void eutetic(double *asn){
	int i, j, k, sw=0;
	double f[4], d[8], org[4], **ja, temp, odd=1;
	ja=(double **)calloc(4,sizeof(double *));
	for(i=0;i<4;i++){
		ja[i]=(double *)calloc(8,sizeof(double));		
	}
	srand( time(NULL) );
	
	asn[0]=0.5;
	asn[1]=0.5;
	asn[2]=0.5;	
	asn[3]=1000;		
	for(i=0;odd>ER && i<50;i++){
		for(j=0;j<4;j++){
			org[j]=asn[j];
		}
		for(j=0;j<4;j++){
			asn[j]=org[j]*1.001;	
			d[0]=16250-12.5*asn[3]+R*asn[3]*log(asn[2]/asn[0])+(la1+la2*asn[3])*pow((1-asn[2]),2)+2*(lb1+lb2*asn[3])*pow((1-asn[2]),2)*asn[2]-(ba1+ba2*asn[3])*pow((1-asn[0]),2)-2*(bb1+bb2*asn[3])*pow((1-asn[0]),2)*asn[0];
			d[1]=7500+R*asn[3]*log(asn[1]/asn[0])+(fa1+fa2*asn[3])*pow((1-asn[1]),2)+2*(fb1+fb2*asn[3])*pow((1-asn[1]),2)*asn[1]-(ba1+ba2*asn[3])*pow((1-asn[0]),2)-2*(bb1+bb2*asn[3])*pow((1-asn[0]),2)*asn[0];
			d[2]=15000-10.0*asn[3]+R*asn[3]*log((1-asn[2])/(1-asn[1]))+(la1+la2*asn[3])*pow(asn[2],2)+(lb1+lb2*asn[3])*pow(asn[2],2)*(2*asn[2]-1)-(fa1+fa2*asn[3])*pow(asn[1],2)-(fb1+fb2*asn[3])*pow(asn[1],2)*(2*asn[1]-1);
			d[3]=10000+R*asn[3]*log((1-asn[0])/(1-asn[1]))+(ba1+ba2*asn[3])*pow(asn[0],2)+(bb1+bb2*asn[3])*pow(asn[0],2)*(2*asn[0]-1)-(fa1+fa2*asn[3])*pow(asn[1],2)-(fb1+fb2*asn[3])*pow(asn[1],2)*(2*asn[1]-1);
			asn[j]=org[j]*0.999;
			d[4]=16250-12.5*asn[3]+R*asn[3]*log(asn[2]/asn[0])+(la1+la2*asn[3])*pow((1-asn[2]),2)+2*(lb1+lb2*asn[3])*pow((1-asn[2]),2)*asn[2]-(ba1+ba2*asn[3])*pow((1-asn[0]),2)-2*(bb1+bb2*asn[3])*pow((1-asn[0]),2)*asn[0];
			d[5]=7500+R*asn[3]*log(asn[1]/asn[0])+(fa1+fa2*asn[3])*pow((1-asn[1]),2)+2*(fb1+fb2*asn[3])*pow((1-asn[1]),2)*asn[1]-(ba1+ba2*asn[3])*pow((1-asn[0]),2)-2*(bb1+bb2*asn[3])*pow((1-asn[0]),2)*asn[0];
			d[6]=15000-10.0*asn[3]+R*asn[3]*log((1-asn[2])/(1-asn[1]))+(la1+la2*asn[3])*pow(asn[2],2)+(lb1+lb2*asn[3])*pow(asn[2],2)*(2*asn[2]-1)-(fa1+fa2*asn[3])*pow(asn[1],2)-(fb1+fb2*asn[3])*pow(asn[1],2)*(2*asn[1]-1);
			d[7]=10000+R*asn[3]*log((1-asn[0])/(1-asn[1]))+(ba1+ba2*asn[3])*pow(asn[0],2)+(bb1+bb2*asn[3])*pow(asn[0],2)*(2*asn[0]-1)-(fa1+fa2*asn[3])*pow(asn[1],2)-(fb1+fb2*asn[3])*pow(asn[1],2)*(2*asn[1]-1);									
			ja[0][j]=(d[0]-d[4])/(org[j]*0.002);
			ja[1][j]=(d[1]-d[5])/(org[j]*0.002);
			ja[2][j]=(d[2]-d[6])/(org[j]*0.002);
			ja[3][j]=(d[3]-d[7])/(org[j]*0.002);
			asn[j]=org[j];		
		}		
		inverse(4,ja);
		
		f[0]=16250-12.5*asn[3]+R*asn[3]*log(asn[2]/asn[0])+(la1+la2*asn[3])*pow((1-asn[2]),2)+2*(lb1+lb2*asn[3])*pow((1-asn[2]),2)*asn[2]-(ba1+ba2*asn[3])*pow((1-asn[0]),2)-2*(bb1+bb2*asn[3])*pow((1-asn[0]),2)*asn[0];
		f[1]=7500+R*asn[3]*log(asn[1]/asn[0])+(fa1+fa2*asn[3])*pow((1-asn[1]),2)+2*(fb1+fb2*asn[3])*pow((1-asn[1]),2)*asn[1]-(ba1+ba2*asn[3])*pow((1-asn[0]),2)-2*(bb1+bb2*asn[3])*pow((1-asn[0]),2)*asn[0];
		f[2]=15000-10.0*asn[3]+R*asn[3]*log((1-asn[2])/(1-asn[1]))+(la1+la2*asn[3])*pow(asn[2],2)+(lb1+lb2*asn[3])*pow(asn[2],2)*(2*asn[2]-1)-(fa1+fa2*asn[3])*pow(asn[1],2)-(fb1+fb2*asn[3])*pow(asn[1],2)*(2*asn[1]-1);
		f[3]=10000+R*asn[3]*log((1-asn[0])/(1-asn[1]))+(ba1+ba2*asn[3])*pow(asn[0],2)+(bb1+bb2*asn[3])*pow(asn[0],2)*(2*asn[0]-1)-(fa1+fa2*asn[3])*pow(asn[1],2)-(fb1+fb2*asn[3])*pow(asn[1],2)*(2*asn[1]-1);		
		
		for(j=0;j<4;j++){
			temp=0;
			for(k=0;k<4;k++){
				temp=temp+ja[j][k]*f[k];
			}
			asn[j]=asn[j]-temp;				
		}

		for(j=0;j<3;j++){
			if(asn[j]<ER || (1-asn[j])<ER ){
				asn[j]=(double)rand()/RAND_MAX;
				sw=1;
			}
			else{ sw=0;}
		}

		if(asn[3]<0){ 
			asn[3]=asn[3]*(-1.0);
			sw=1;
		}		
		
		if(sw==0){
			f[0]=16250-12.5*asn[3]+R*asn[3]*log(asn[2]/asn[0])+(la1+la2*asn[3])*pow((1-asn[2]),2)+2*(lb1+lb2*asn[3])*pow((1-asn[2]),2)*asn[2]-(ba1+ba2*asn[3])*pow((1-asn[0]),2)-2*(bb1+bb2*asn[3])*pow((1-asn[0]),2)*asn[0];
			f[1]=7500+R*asn[3]*log(asn[1]/asn[0])+(fa1+fa2*asn[3])*pow((1-asn[1]),2)+2*(fb1+fb2*asn[3])*pow((1-asn[1]),2)*asn[1]-(ba1+ba2*asn[3])*pow((1-asn[0]),2)-2*(bb1+bb2*asn[3])*pow((1-asn[0]),2)*asn[0];
			f[2]=15000-10.0*asn[3]+R*asn[3]*log((1-asn[2])/(1-asn[1]))+(la1+la2*asn[3])*pow(asn[2],2)+(lb1+lb2*asn[3])*pow(asn[2],2)*(2*asn[2]-1)-(fa1+fa2*asn[3])*pow(asn[1],2)-(fb1+fb2*asn[3])*pow(asn[1],2)*(2*asn[1]-1);
			f[3]=10000+R*asn[3]*log((1-asn[0])/(1-asn[1]))+(ba1+ba2*asn[3])*pow(asn[0],2)+(bb1+bb2*asn[3])*pow(asn[0],2)*(2*asn[0]-1)-(fa1+fa2*asn[3])*pow(asn[1],2)-(fb1+fb2*asn[3])*pow(asn[1],2)*(2*asn[1]-1);
			odd=fabs(f[0]);
			for(j=1;j<4;j++){
				if(odd<fabs(f[j])) odd=fabs(f[j]);
			}
		}		
	}
	te=asn[3];
	printf("\n i is %d",i);
	printf("\n x1=%le, x2=%le, x3=%le, te=%le",asn[0],asn[1],asn[2],asn[3]);	
	getch();
		
}

void b_f(double *asn){	
	double **matrix, x1, x2, t, f1, f2, odd, a,b,c,d,tx1,tx2;
	int i, j, n=2;
	FILE *bf;
	bf=fopen("bf.txt","w+");	
	matrix=(double **)calloc(n,sizeof(double *));
	for(i=0;i<n;i++){
		matrix[i]=(double *)calloc(n*2,sizeof(double));
		matrix[i][i+n]=1;
	}	

	srand( time(NULL) );	
	fprintf(bf,"    T      |   Xks   |   Xks   \n");
	x1=asn[1];
	x2=asn[0];
	for(t=(double)((int)te);t>300;t=t-1){							
		odd=1;
		for(j=0;odd>ER && j<50;j++){
			tx1=x1;
			tx2=x2;
			x1=tx1*0.999;
			a=7500+R*t*log(x1/x2)+(fa1+fa2*t)*pow((1-x1),2)+2*(fb1+fb2*t)*pow((1-x1),2)*x1-(ba1+ba2*t)*pow((1-x2),2)-2*(bb1+bb2*t)*pow((1-x2),2)*x2;
			b=10000+R*t*log((1-x2)/(1-x1))+(ba1+ba2*t)*pow(x2,2)+(bb1+bb2*t)*pow(x2,2)*(2*x2-1)-(fa1+fa2*t)*pow(x1,2)-(fb1+fb2*t)*pow(x1,2)*(2*x1-1);
			x1=tx1*1.001;
			c=7500+R*t*log(x1/x2)+(fa1+fa2*t)*pow((1-x1),2)+2*(fb1+fb2*t)*pow((1-x1),2)*x1-(ba1+ba2*t)*pow((1-x2),2)-2*(bb1+bb2*t)*pow((1-x2),2)*x2;
			d=10000+R*t*log((1-x2)/(1-x1))+(ba1+ba2*t)*pow(x2,2)+(bb1+bb2*t)*pow(x2,2)*(2*x2-1)-(fa1+fa2*t)*pow(x1,2)-(fb1+fb2*t)*pow(x1,2)*(2*x1-1);
			matrix[0][0]=(c-a)/(0.002*tx1);			
			matrix[1][0]=(d-b)/(0.002*tx1);
			x1=tx1;
			x2=tx2*0.999;
			a=7500+R*t*log(x1/x2)+(fa1+fa2*t)*pow((1-x1),2)+2*(fb1+fb2*t)*pow((1-x1),2)*x1-(ba1+ba2*t)*pow((1-x2),2)-2*(bb1+bb2*t)*pow((1-x2),2)*x2;
			b=10000+R*t*log((1-x2)/(1-x1))+(ba1+ba2*t)*pow(x2,2)+(bb1+bb2*t)*pow(x2,2)*(2*x2-1)-(fa1+fa2*t)*pow(x1,2)-(fb1+fb2*t)*pow(x1,2)*(2*x1-1);
			x2=tx2*1.001;
			c=7500+R*t*log(x1/x2)+(fa1+fa2*t)*pow((1-x1),2)+2*(fb1+fb2*t)*pow((1-x1),2)*x1-(ba1+ba2*t)*pow((1-x2),2)-2*(bb1+bb2*t)*pow((1-x2),2)*x2;
			d=10000+R*t*log((1-x2)/(1-x1))+(ba1+ba2*t)*pow(x2,2)+(bb1+bb2*t)*pow(x2,2)*(2*x2-1)-(fa1+fa2*t)*pow(x1,2)-(fb1+fb2*t)*pow(x1,2)*(2*x1-1);
			matrix[0][1]=(c-a)/(0.002*tx2);
			matrix[1][1]=(d-b)/(0.002*tx2);			
			x2=tx2; // ں 
					
			inverse(n,matrix);	//
			
			f1=7500+R*t*log(x1/x2)+(fa1+fa2*t)*pow((1-x1),2)+2*(fb1+fb2*t)*pow((1-x1),2)*x1-(ba1+ba2*t)*pow((1-x2),2)-2*(bb1+bb2*t)*pow((1-x2),2)*x2;
			f2=10000+R*t*log((1-x2)/(1-x1))+(ba1+ba2*t)*pow(x2,2)+(bb1+bb2*t)*pow(x2,2)*(2*x2-1)-(fa1+fa2*t)*pow(x1,2)-(fb1+fb2*t)*pow(x1,2)*(2*x1-1);					
			x1=x1-(matrix[0][0]*f1+matrix[0][1]*f2);
			x2=x2-(matrix[1][0]*f1+matrix[1][1]*f2); //  ȯ
			
			while(x1<ER || (1-x1)<ER){			
				x1=(double)rand()/RAND_MAX;				
			}
			while(x2<ER || (1-x2)<ER){			
				x2=(double)rand()/RAND_MAX;				
			} //   
			
			odd=fabs(f1);
			if(fabs(f2)>fabs(f1)) odd=fabs(f2);	//  Ȯ						
		}

		if(odd<ER) fprintf(bf,"%9lf|%9lf|%9lf\n",t,x1,x2);
		else fprintf(bf,"%9lf|   NULL  |   NULL  \n",t);
	}
	fclose(bf);
}

void l_f(double *asn){	
	double **matrix, x1, x2, t, f1, f2, odd, a,b,c,d,tx1,tx2;
	int i, j, n=2;
	FILE *lf;
	lf=fopen("lf.txt","w+");	
	matrix=(double **)calloc(n,sizeof(double *));
	for(i=0;i<n;i++){
		matrix[i]=(double *)calloc(n*2,sizeof(double));
		matrix[i][i+n]=1;
	}	

	srand( time(NULL) );	
	fprintf(lf,"    T      |   Xks   |   Xks   \n");

	x1=asn[2];
	x2=asn[1];
	for(t=(double)((int)te);t<1500;t=t+1){							
		odd=1;
		for(j=0;odd>ER && j<50;j++){		
			
			tx1=x1;
			tx2=x2;
			x1=tx1*0.999;
			a=8750-12.5*t+8.314*t*log(x1/x2)+(la1+la2*t)*(1-x1)*(1-x1)+2*(lb1+lb2*t)*(1-x1)*(1-x1)*x1-(fa1+fa2*t)*(1-x2)*(1-x2)-2*(fb1+fb2*t)*(1-x2)*(1-x2)*x2;
			b=15000-10*t+8.314*t*log((1-x1)/(1-x2))+(la1+la2*t)*x1*x1+(lb1+lb2*t)*x1*x1*(2*x1-1)-(fa1+fa2*t)*x2*x2-(fb1+fb2*t)*x2*x2*(2*x2-1);
			x1=tx1*1.001;
			c=8750-12.5*t+8.314*t*log(x1/x2)+(la1+la2*t)*(1-x1)*(1-x1)+2*(lb1+lb2*t)*(1-x1)*(1-x1)*x1-(fa1+fa2*t)*(1-x2)*(1-x2)-2*(fb1+fb2*t)*(1-x2)*(1-x2)*x2;
			d=15000-10*t+8.314*t*log((1-x1)/(1-x2))+(la1+la2*t)*x1*x1+(lb1+lb2*t)*x1*x1*(2*x1-1)-(fa1+fa2*t)*x2*x2-(fb1+fb2*t)*x2*x2*(2*x2-1);
			matrix[0][0]=(c-a)/(0.002*tx1);			
			matrix[1][0]=(d-b)/(0.002*tx1);
			x1=tx1;
			x2=tx2*0.999;
			a=8750-12.5*t+8.314*t*log(x1/x2)+(la1+la2*t)*(1-x1)*(1-x1)+2*(lb1+lb2*t)*(1-x1)*(1-x1)*x1-(fa1+fa2*t)*(1-x2)*(1-x2)-2*(fb1+fb2*t)*(1-x2)*(1-x2)*x2;
			b=15000-10*t+8.314*t*log((1-x1)/(1-x2))+(la1+la2*t)*x1*x1+(lb1+lb2*t)*x1*x1*(2*x1-1)-(fa1+fa2*t)*x2*x2-(fb1+fb2*t)*x2*x2*(2*x2-1);
			x2=tx2*1.001;
			c=8750-12.5*t+8.314*t*log(x1/x2)+(la1+la2*t)*(1-x1)*(1-x1)+2*(lb1+lb2*t)*(1-x1)*(1-x1)*x1-(fa1+fa2*t)*(1-x2)*(1-x2)-2*(fb1+fb2*t)*(1-x2)*(1-x2)*x2;
			d=15000-10*t+8.314*t*log((1-x1)/(1-x2))+(la1+la2*t)*x1*x1+(lb1+lb2*t)*x1*x1*(2*x1-1)-(fa1+fa2*t)*x2*x2-(fb1+fb2*t)*x2*x2*(2*x2-1);
			matrix[0][1]=(c-a)/(0.002*tx2);
			matrix[1][1]=(d-b)/(0.002*tx2);		
			x2=tx2;		// ں  	
			
			inverse(n,matrix);
			
			f1=8750-12.5*t+8.314*t*log(x1/x2)+(la1+la2*t)*(1-x1)*(1-x1)+2*(lb1+lb2*t)*(1-x1)*(1-x1)*x1-(fa1+fa2*t)*(1-x2)*(1-x2)-2*(fb1+fb2*t)*(1-x2)*(1-x2)*x2;
			f2=15000-10*t+8.314*t*log((1-x1)/(1-x2))+(la1+la2*t)*x1*x1+(lb1+lb2*t)*x1*x1*(2*x1-1)-(fa1+fa2*t)*x2*x2-(fb1+fb2*t)*x2*x2*(2*x2-1);		
			x1=x1-(matrix[0][0]*f1+matrix[0][1]*f2);
			x2=x2-(matrix[1][0]*f1+matrix[1][1]*f2);  //  
			
			while(x1<ER || (1-x1)<ER){			
				x1=(double)rand()/RAND_MAX;
			}
			while(x2<ER || (1-x2)<ER){			
				x2=(double)rand()/RAND_MAX;	
			}   //    

			odd=fabs(f1);
			if(fabs(f2)>fabs(f1)) odd=fabs(f2);	  //  Ȯ								
		}

		if(odd<ER) fprintf(lf,"%9lf|%9lf|%9lf\n",t,x1,x2);
		else fprintf(lf,"%9lf|   NULL  |   NULL  \n",t);
	}
	fclose(lf);
}

void l_b(double *asn){	
	double **matrix, x1, x2, t, f1, f2, odd, a,b,c,d,tx1,tx2;
	int i, j, n=2;
	FILE *lb;
	lb=fopen("lb.txt","w+");	
	matrix=(double **)calloc(n,sizeof(double *));
	for(i=0;i<n;i++){
		matrix[i]=(double *)calloc(n*2,sizeof(double));
		matrix[i][i+n]=1;
	}	

	srand( time(NULL) );	
	fprintf(lb,"    T      |   Xks   |   Xks   \n");

	x1=asn[2];
	x2=asn[1];	
	for(t=(double)((int)te);t<1300;t=t+1){							
		odd=1;
		for(j=0;odd>ER && j<50;j++){		
			
			tx1=x1;
			tx2=x2;
			x1=tx1*0.999;
			a=16250-12.5*t+8.314*t*log(x2/x1)+(la1+la2*t)*(1-x2)*(1-x2)+2*(lb1+lb2*t)*(1-x2)*(1-x2)*x2-(ba1+ba2*t)*(1-x1)*(1-x1)-2*(bb1+bb2*t)*(1-x1)*(1-x1)*x1;
			b=5000-10*t+8.314*t*log((1-x2)/(1-x1))+(la1+la2*t)*x2*x2+(lb1+lb2*t)*x2*x2*(2*x2-1)-(ba1+ba2*t)*x1*x1-(bb1+bb2*t)*x1*x1*(2*x1-1);
			x1=tx1*1.001;
			c=16250-12.5*t+8.314*t*log(x2/x1)+(la1+la2*t)*(1-x2)*(1-x2)+2*(lb1+lb2*t)*(1-x2)*(1-x2)*x2-(ba1+ba2*t)*(1-x1)*(1-x1)-2*(bb1+bb2*t)*(1-x1)*(1-x1)*x1;
			d=5000-10*t+8.314*t*log((1-x2)/(1-x1))+(la1+la2*t)*x2*x2+(lb1+lb2*t)*x2*x2*(2*x2-1)-(ba1+ba2*t)*x1*x1-(bb1+bb2*t)*x1*x1*(2*x1-1);
			matrix[0][0]=(c-a)/(0.002*tx1);			
			matrix[1][0]=(d-b)/(0.002*tx1);
			x1=tx1;
			x2=tx2*0.999;
			a=16250-12.5*t+8.314*t*log(x2/x1)+(la1+la2*t)*(1-x2)*(1-x2)+2*(lb1+lb2*t)*(1-x2)*(1-x2)*x2-(ba1+ba2*t)*(1-x1)*(1-x1)-2*(bb1+bb2*t)*(1-x1)*(1-x1)*x1;
			b=5000-10*t+8.314*t*log((1-x2)/(1-x1))+(la1+la2*t)*x2*x2+(lb1+lb2*t)*x2*x2*(2*x2-1)-(ba1+ba2*t)*x1*x1-(bb1+bb2*t)*x1*x1*(2*x1-1);
			x2=tx2*1.001;
			c=16250-12.5*t+8.314*t*log(x2/x1)+(la1+la2*t)*(1-x2)*(1-x2)+2*(lb1+lb2*t)*(1-x2)*(1-x2)*x2-(ba1+ba2*t)*(1-x1)*(1-x1)-2*(bb1+bb2*t)*(1-x1)*(1-x1)*x1;
			d=5000-10*t+8.314*t*log((1-x2)/(1-x1))+(la1+la2*t)*x2*x2+(lb1+lb2*t)*x2*x2*(2*x2-1)-(ba1+ba2*t)*x1*x1-(bb1+bb2*t)*x1*x1*(2*x1-1);
			matrix[0][1]=(c-a)/(0.002*tx2);
			matrix[1][1]=(d-b)/(0.002*tx2);		
			x2=tx2;		// ں  	
			
			inverse(n,matrix);
			
			f1=16250-12.5*t+8.314*t*log(x2/x1)+(la1+la2*t)*(1-x2)*(1-x2)+2*(lb1+lb2*t)*(1-x2)*(1-x2)*x2-(ba1+ba2*t)*(1-x1)*(1-x1)-2*(bb1+bb2*t)*(1-x1)*(1-x1)*x1;
			f2=5000-10*t+8.314*t*log((1-x2)/(1-x1))+(la1+la2*t)*x2*x2+(lb1+lb2*t)*x2*x2*(2*x2-1)-(ba1+ba2*t)*x1*x1-(bb1+bb2*t)*x1*x1*(2*x1-1);
			x1=x1-(matrix[0][0]*f1+matrix[0][1]*f2);
			x2=x2-(matrix[1][0]*f1+matrix[1][1]*f2);  //  
			
			while(x1<ER || (1-x1)<ER){			
				x1=(double)rand()/RAND_MAX;
			}
			while(x2<ER || (1-x2)<ER){			
				x2=(double)rand()/RAND_MAX;	
			}   //    

			odd=fabs(f1);
			if(fabs(f2)>fabs(f1)) odd=fabs(f2);	  //  Ȯ								
		}

		if(odd<ER) fprintf(lb,"%9lf|%9lf|%9lf\n",t,x1,x2);
		else fprintf(lb,"%9lb|   NULL  |   NULL  \n",t);
	}
	fclose(lb);
}

void inverse(int n, double **matrix){
	int i, j, k;	
	double temp;
	for(i=0;i<n;i++){
		for(j=0;j<n;j++){
			if(i==j) matrix[i][j+n]=1;
			if(i!=j) matrix[i][j+n]=0;
		}
	}
//	nomalize(n, matrix, 0);	
//	pivot(n,matrix,0,0);
	for(i=0;i<n;i++){		
//		pivot(n, matrix, i, i);
		for(j=0;j<n;j++){
			if(j!=i){
				temp=matrix[j][i]/matrix[i][i];
				for(k=0;k<n*2;k++){
					matrix[j][k]=matrix[j][k]-matrix[i][k]*temp;
				}				
			}
			temp=matrix[j][j];
			for(k=0;k<n*2;k++){
				matrix[j][k]=matrix[j][k]/temp;
			}
		}		
	}
	for(i=0;i<n;i++){
		for(j=0;j<n;j++){
			matrix[i][j]=matrix[i][j+n];
		}
	}
}
	



		



